/*
 * arch/arm/mach-cxd4105/mm.c
 *
 * I/O space mapping
 *
 * Copyright 2005,2006 Sony Corporation
 *
 * This code is based on arch/arm/mach-integrator/mm.c.
 */
/*
 *  linux/arch/arm/mach-integrator/mm.c
 *
 *  Extra MM routines for the ARM Integrator board
 *
 *  Copyright (C) 1999,2000 Arm Limited
 *  Copyright (C) 2000 Deep Blue Solutions Ltd
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <linux/device.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/arch/regs-uart.h>
#include <asm/io.h>
#include <asm/pgtable.h>
#include <asm/page.h>

#include <asm/mach/map.h>

#include "mm.h"

/*
  Logical    Physical
  C0000000   30000000 SDRAM (EMC CS1)
  
  E0000000   70000000 Peripherals (AHB)
  E0C00000   -
  E2000000   72000000 Peripherals (APB)
  Ea000000   -

  FFFF0000   xxxxx000 4K High Vector arch/mm/mm-armv.c
  FFFF2000   FFFF2000 8K ETM
*/
 
static struct map_desc cxd4105_io_desc[] __initdata = {
 { IO_ADDRESS(CXD4105_AHB_BASE), CXD4105_AHB_BASE, CXD4105_AHB_SIZE, MT_DEVICE },
 { IO_ADDRESS(CXD4105_APB_BASE), CXD4105_APB_BASE, CXD4105_APB_SIZE, MT_DEVICE },
 { VA_ETM_BASE, ETM_BASE, ETM_SIZE, MT_DEVICE},

#if defined(CONFIG_ARCH_CXD4108)
 // 9118test from by T.Ogawa
 /* EF000000-EF000FFF: EMC CS2(LAN9118) Area Define */
 { 0xEF000000,0x40000000,0x1000,MT_DEVICE },
 // 9118test to   by T.Ogawa
#endif

};

void __init cxd4105_map_io(void)
{
	iotable_init(cxd4105_io_desc, ARRAY_SIZE(cxd4105_io_desc));
}
