/*
 * arch/arm/mach-cxd4105/target_init.c
 *
 * Serialized and ordered initcall for target specific static kernel modules.
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
/*
 * Each static driver should care that his/her init() 
 * is called from module_init() macro or this target_init().
 *
 */


#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>



#ifdef CONFIG_ARCH_CXD4105BASED

extern int __init sonymisc_init(void);
extern int __init gpio_core_init(void);
#ifdef CONFIG_ARCH_CXD4108
extern int __init gpio_cxd4108_init(void);
#else /* (CONFIG_ARCH_CXD4105) */
extern int __init gpio_cxd4105_init(void);
#endif
extern int __init gpio_dev_init(void);
extern int __init MGC_ModuleInit(void);
extern int __init usb_event_module_init(void);
extern int __init usb_otgcore_module_init(void);
extern int __init usb_gcore_module_init(void);

static int __init target_init(void)
{
    printk(KERN_INFO "%s: CXD4105/CXD4108\n", __func__);

    /*
     * sample
     */

#ifdef CONFIG_CXD4105_SAMPLE_CODE
    #error "This is sample code."
    cxd4105_sample_code_init();
#endif


    /*
     * put the static moudle's init()s here.
     */
    sonymisc_init();
    gpio_core_init();
#if defined(CONFIG_ARCH_CXD4108)
    gpio_cxd4108_init();
#else
    gpio_cxd4105_init();
#endif
    gpio_dev_init();

#if defined(CONFIG_USB_MCD_CD)
    MGC_ModuleInit();
#endif

#if defined(CONFIG_USB_EVENT)
    usb_event_module_init();
#endif

#if defined(CONFIG_USB_OTG_CORE)
    usb_otgcore_module_init();
#endif

#if defined(CONFIG_USB_GADGET_CORE)
    usb_gcore_module_init();
#endif

    return 0;
}

/* module_init() is too early. */
late_initcall(target_init);


#endif  /* end of ARCH_CXD4105BASED */
