/*
 * include/asm-arm/arch-cxd4105/debug-macro.S
 *
 * Debugging macro include header
 *
 * Copyright 2005,2006 Sony Corporation
 *
 * This code is based on include/asm-arm/arch-integrator/debug-macro.S.
 */
/* linux/include/asm-arm/arch-integrator/debug-macro.S
 *
 * Debugging macro include header
 *
 *  Copyright (C) 1994-1999 Russell King
 *  Moved from linux/arch/arm/kernel/debug.S by Ben Dooks
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
*/

		.macro	addruart,rx
		mrc	p15, 0, \rx, c1, c0
		tst	\rx, #1			@ MMU enabled?

		moveq	\rx, #0x74000000	@ phy addr of UART
		movne	\rx, #0xe4000000	@ virtual addr
#ifdef CONFIG_CXD4105_UART3
		orr	\rx, \rx, #0x00500000
#else
#if defined(CONFIG_ARCH_CXD4108)
		orr	\rx, \rx, #0x00200000
#else  /* (CONFIG_ARCH_CXD4105) */
		orr	\rx, \rx, #0x00400000
#endif
#endif

		.endm

		.macro	senduart,rd,rx
		str	\rd, [\rx, #0x0]	@ UARTDR
		.endm

		.macro	waituart,rd,rx
1001:		ldr	\rd, [\rx, #0x18]	@ UARTFLG
		tst	\rd, #1 << 5		@ UARTFLGUTXFF - 1 when full
		bne	1001b
		.endm

		.macro	busyuart,rd,rx
1001:		ldr	\rd, [\rx, #0x18]	@ UARTFLG
		tst	\rd, #1 << 3		@ UARTFLGUBUSY - 1 when busy
		bne	1001b
		.endm
