/*
 * include/asm-arm/arch-cxd4105/irqs.h
 *
 * IRQ and cascade IRQ definitions
 *
 * Copyright 2005,2006 Sony Corporation
 *
 * This code is based on include/asm-arm/arch-integrator/irqs.h.
 */
/*
 *  linux/include/asm-arm/arch-integrator/irqs.h
 *
 *  Copyright (C) 1999 ARM Limited
 *  Copyright (C) 2000 Deep Blue Solutions Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <asm/arch/platform.h>
#include <asm/arch/regs-intctrl.h>

#define IRQ_UART	INT_UART
#define IRQ_SSP		INT_SSP
#define IRQ_TIMER	INT_TIMER
#define IRQ_DMAC	INT_DMAC
#define IRQ_SIRCS	INT_SIRCS
#define IRQ_I2C		INT_I2C
#define IRQ_JOG		INT_JOG
#define IRQ_SIO		INT_SIO
#define IRQ_I2S		INT_I2S
#define IRQ_ATA		INT_ATA
#define IRQ_CF		INT_CF
#define IRQ_CML		INT_CML
#define IRQ_PCI		INT_PCI
#define IRQ_USB		INT_USB
#define IRQ_MS		INT_MS
#define IRQ_MSIO	INT_MSIO
#define IRQ_TPU		INT_TPU
#define IRQ_ADC		INT_ADC
#define IRQ_TP		INT_TP
#define IRQ_GPIO	INT_GPIO
#define IRQ_MXX		INT_MXX
#define IRQ_MBOX	INT_MBOX
#define IRQ_VIDEO	INT_VIDEO
#define IRQ_CODEC	INT_CODEC
#define IRQ_WSX		INT_WSX
#define IRQ_IMG		INT_IMG
#define IRQ_IMGMC	INT_IMGMC
#define IRQ_BUS		INT_BUS
#define IRQ_IMGV	INT_IMGV
#define IRQ_SYSV	INT_SYSV
#define IRQ_AUDIO	INT_AUDIO

/* IRQ for cascade */
#define IRQ_UART0	32
#define IRQ_UART1	(IRQ_UART0+1)
#define IRQ_UART2	(IRQ_UART0+2)
#define IRQ_UART3	(IRQ_UART0+3)
#define IRQ_UARTx(x)	(IRQ_UART0+(x))

#define IRQ_SSP0	36
#define IRQ_SSP1	(IRQ_SSP0+1)

#define IRQ_TIMER0	38
#define IRQ_TIMER1	(IRQ_TIMER0+1)
#define IRQ_TIMER2	(IRQ_TIMER0+2)
#define IRQ_TIMER3	(IRQ_TIMER0+3)
#define IRQ_TIMER4	(IRQ_TIMER0+4)
#define IRQ_TIMER5	(IRQ_TIMER0+5)
#define IRQ_TIMER6	(IRQ_TIMER0+6)
#define IRQ_TIMER7	(IRQ_TIMER0+7)
#define IRQ_TIMER8	(IRQ_TIMER0+8)
#define IRQ_TIMER9	(IRQ_TIMER0+9)
#define IRQ_TIMER10	(IRQ_TIMER0+10)
#define IRQ_TIMER11	(IRQ_TIMER0+11)
#define IRQ_TIMER12	(IRQ_TIMER0+12)
#define IRQ_TIMER13	(IRQ_TIMER0+13)
#define IRQ_WDT		(IRQ_TIMER0+14)
#define IRQ_TIMERx(x)	(IRQ_TIMER0+(x))

#define IRQ_DMAC0	54		/* FIFO32 */
#define IRQ_DMAC1	(IRQ_DMAC0+1)	/* FIFO16 */

#define IRQ_DMA0_0	56
#define IRQ_DMA0_1	(IRQ_DMA0_0+1)
#define IRQ_DMA0_2	(IRQ_DMA0_0+2)
#define IRQ_DMA0_3	(IRQ_DMA0_0+3)
#define IRQ_DMA0_4	(IRQ_DMA0_0+4)
#define IRQ_DMA0_5	(IRQ_DMA0_0+5)
#define IRQ_DMA0_6	(IRQ_DMA0_0+6)
#define IRQ_DMA0_7	(IRQ_DMA0_0+7)
#define IRQ_DMA0x(x)	(IRQ_DMA0_0+(x))

#define IRQ_SIRCSTX	64
#define IRQ_SIRCSRX	(IRQ_SIRCSTX+1)
#define IRQ_SIRCSROR	(IRQ_SIRCSTX+2)

#define IRQ_JOG0	68
#define IRQ_JOG1	(IRQ_JOG0+1)

#define IRQ_SIO0	70
#define IRQ_SIO1	(IRQ_SIO0+1)
#define IRQ_SIO2	(IRQ_SIO0+2)
#define IRQ_SIO3	(IRQ_SIO0+3)

#define IRQ_I2S0	74
#define IRQ_I2S1	(IRQ_I2S0+1)
#define IRQ_I2S2	(IRQ_I2S0+2)

#define IRQ_PCI_BRIDGE	78
#define IRQ_PCI_INT0	(IRQ_PCI_BRIDGE+1)
#define IRQ_PCI_INT1	(IRQ_PCI_BRIDGE+2)
#define IRQ_PCI_INT2	(IRQ_PCI_BRIDGE+3)
#define IRQ_PCI_INT3	(IRQ_PCI_BRIDGE+4)
#define IRQ_PCI_INTA	IRQ_PCI_INT3
#define IRQ_PCI_INTB	IRQ_PCI_INT2
#define IRQ_PCI_INTC	IRQ_PCI_INT1
#define IRQ_PCI_INTD	IRQ_PCI_INT0

#define IRQ_USB_HS	86
#define IRQ_USB_DMAC	(IRQ_USB_HS+1)

#define IRQ_TPU0	88
#define IRQ_TPU1	(IRQ_TPU0+1)
#define IRQ_TPU2	(IRQ_TPU0+2)
#define IRQ_TPU3	(IRQ_TPU0+3)
#define IRQ_TPU4	(IRQ_TPU0+4)

#define IRQ_ADC0	96
#define IRQ_ADC1	(IRQ_ADC0+1)

#define IRQ_GPIO0	98
#define IRQ_GPIO1	(IRQ_GPIO0+1)
#define IRQ_GPIO2	(IRQ_GPIO0+2)
#define IRQ_GPIO3	(IRQ_GPIO0+3)
#define IRQ_GPIO4	(IRQ_GPIO0+4)
#define IRQ_GPIO5	(IRQ_GPIO0+5)
#define IRQ_GPIO6	(IRQ_GPIO0+6)
#define IRQ_GPIO7	(IRQ_GPIO0+7)
#define IRQ_GPIO8	(IRQ_GPIO0+8)
#define IRQ_GPIO9	(IRQ_GPIO0+9)
#define IRQ_GPIO10	(IRQ_GPIO0+10)
#define IRQ_GPIO11	(IRQ_GPIO0+11)
#define IRQ_GPIO12	(IRQ_GPIO0+12)
#define IRQ_GPIO13	(IRQ_GPIO0+13)
#define IRQ_GPIO14	(IRQ_GPIO0+14)
#define IRQ_GPIO15	(IRQ_GPIO0+15)
#define IRQ_GPIOx(x)	(IRQ_GPIO0+(x))

#define IRQ_CF0		114
#define IRQ_EXIO	(IRQ_CF0 + 1)

#define IRQ_SYSV0	116
#define IRQ_SYSV1	(IRQ_SYSV0+1)
#define IRQ_SYSV2	(IRQ_SYSV0+2)
#define IRQ_SYSV3	(IRQ_SYSV0+3)
#define IRQ_SYSV4	(IRQ_SYSV0+4)
#define IRQ_SYSV5	(IRQ_SYSV0+5)
#define IRQ_SYSV6	(IRQ_SYSV0+6)
#define IRQ_SYSV7	(IRQ_SYSV0+7)
#define IRQ_SYSV8	(IRQ_SYSV0+8)

#define NR_IRQS		(IRQ_SYSV8 + 1)
