/*
 * include/asm-arm/arch-cxd4105/pci.h
 *
 * PCI bridge definitions
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __CXD4105_PCI_H
#define __CXD4105_PCI_H

/* PCI window (MEM, NonPrefetch) */
#define CXD4105_PCIWINDOW_BASE    0xD0000000
#define CXD4105_PCIWINDOW_SIZE    0x20000000

/* PCI window (I/O, Config) */
#define CXD4105_PCIWINDOW_IOBASE  0x70010000
#define CXD4105_PCIWINDOW_IOSIZE  0x00010000

#define PCI_CFGREG(x)		(IO_ADDRESS(CXD4105_PCIWINDOW_IOBASE)+(x))
#define PCI_IDSEL(x)		(11 + (x))
#define PCI_CXD4105_SLOT	0

#endif /* __CXD4105_PCI_H */
