/*
 * include/asm-arm/arch-cxd4105/regs-emc.h
 *
 * CXD4105 address map
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __REGS_EMC_H__
#define __REGS_EMC_H__

#define CXD4105_EMC_BASE		(CXD4105_AHB_BASE+SZ_1M*1)
#define CXD4105_EMC_SIZE                (SZ_1M)
#define CXD4105_EMC_VIRT_BASE 		IO_ADDRESS(CXD4105_EMC_BASE)
/* register offset */
#define EMC_STATUS		0x00
#  define EMC_SDRAM_BUSY		(1<<10)
#define EMC_TRANS_CTRL		0x04
#define EMC_PHY_SDR_CMD		0x20
#define EMC_PHY_SDR_ADDR	0x24
#define EMC_PHY_SDR_DATA	0x28
#define EMC_PHY_SDR_PWS		0x2C
#define EMC_PHY_SDR_PWC		0x30
#define EMC_PHY_SDR_CFG		0x34
#define EMC_PHY_SB_CFG		0x94

#endif /* __REGS_EMC_H__ */
