/*
 * include/asm-arm/arch-cxd4105/regs-gpio.h
 *
 * CXD4105 address map
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __REGS_GPIO_H__
#define __REGS_GPIO_H__

#if defined(CONFIG_ARCH_CXD4108)
#define CXD4105_GPIO(x)		(CXD4105_APB2_BASE+SZ_1M*7+0x10000+0x10000*(x))
#define CXD4105_GPIOSYS		(CXD4105_GPIO(8))
#else /* (CXD4105) */
#define CXD4105_GPIO(x)		(CXD4105_APB2_BASE+SZ_1M*7+0x1000+0x100*(x))
#define CXD4105_GPIOSYS		(CXD4105_GPIO(20))
#endif

#define CXD4105_AGPIOSYS	(CXD4105_APB2_BASE+SZ_1M*7+0)

#define VA_GPIO(x)		IO_ADDRESS(CXD4105_GPIO(x))
#define VA_GPIOSYS		IO_ADDRESS(CXD4105_GPIOSYS)
#define VA_AGPIOSYS		IO_ADDRESS(CXD4105_AGPIOSYS)

#if defined(CONFIG_ARCH_CXD4108)
#define CXD4105_OCTRL           (0x767a0000)
#else /* CXD4105 */
#define CXD4105_OCTRL           (0x76708000)
#endif
#define VA_OCTRL(x)             (IO_ADDRESS(CXD4105_OCTRL) + (x)*0x100)

/* GPIO registers */
#define GPIO_DIR		0x00
#define GPIO_DATA_READ		0x04
#define GPIO_DATA_SET		0x08
#define GPIO_DATA_CLEAR		0x0c

/* GPIOsys registers */
#define GPIO_INTLS		0x10
#define GPIO_INTHE		0x14
#define GPIO_INTLE		0x18
#define GPIO_INTEN		0x1c
#define GPIO_INTST		0x20	/* read only */
#define GPIO_INTCL		0x24	/* write only */
#define GPIO_INPUTEN		0x28
#define GPIO_RESEN		0x2c
#define GPIO_PUPD		0x30

/* GPIOeasy registers */
#define GPIOE_INEN		0x10
#define GPIOE_PORTSEL(x)	(0x14 + (x)*4)
#define GPIOE_HOLDEN		0x54
#define GPIOE_RESEN		0x58
#define GPIOE_PUPD		0x5c

#endif /* __REGS_GPIO_H__ */
