/*
 * include/asm-arm/arch-cxd4105/regs-intctrl.h
 *
 * CXD4105 address map
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __REGS_INTCTRL_H__
#define __REGS_INTCTRL_H__

#ifdef CONFIG_CXD4105_UART3
#define INT_CTRL(x)		(IO_ADDRESS(CXD4105_APB2_BASE+SZ_1M*6) + (x))
#else
#define INT_CTRL(x)		(IO_ADDRESS(CXD4105_APB2_BASE+SZ_1M*5) + (x))
#endif

/* registers */
#define IRQ_STATUS                      0x00
#define FIQ_STATUS                      0x04
#define IRQ_RAW_STATUS                  0x08
#define IRQ_SELECT                      0x0c
#define IRQ_ENABLE                      0x10
#define IRQ_ENABLE_SET                  0x10
#define IRQ_ENABLE_CLEAR                0x14

#define INT_SOFT_SET                    0x18
#define INT_SOFT_CLEAR                  0x1c

#define UART_RAW_STATUS			0x100
#define UART_STATUS			0x104
#define UART_ENABLE			0x108
#define UART_ENABLE_CLEAR		0x10C
#define UART_SOFTINT_SET		0x110
#define UART_SOFTINT_CLEAR		0x114
# define  UART_UART0                      0x1
# define  UART_UART1                      0x2
# define  UART_UART2                      0x4
# define  UART_UART3                      0x8
# define  UART_VALIDBITMASK		  0x0000000f

#define SSP_RAW_STATUS			0x120
#define SSP_STATUS			0x124
#define SSP_ENABLE			0x128
#define SSP_ENABLE_CLEAR		0x12C
#define SSP_SOFTINT_SET			0x130
#define SSP_SOFTINT_CLEAR		0x134
# define  SSP_VALIDBITMASK		  0x00000003

#define TIMER_RAW_STATUS		0x140
#define TIMER_STATUS			0x144
#define TIMER_ENABLE			0x148
#define TIMER_ENABLE_CLEAR		0x14C
#define TIMER_SOFTINT_SET		0x150
#define TIMER_SOFTINT_CLEAR		0x154
# define  TIMER_VALIDBITMASK		  0x00007fff

#define DMAC_RAW_STATUS			0x160
#define DMAC_STATUS			0x164
#define DMAC_ENABLE			0x168
#define DMAC_ENABLE_CLEAR		0x16C
#define DMAC_SOFTINT_SET		0x170
#define DMAC_SOFTINT_CLEAR		0x174
# define  DMAC_HOST			  0x01 /* DMAC0 (32byte FIFO) */

#define SIRCS_RAW_STATUS		0x180
#define SIRCS_STATUS			0x184
#define SIRCS_ENABLE			0x188
#define SIRCS_ENABLE_CLEAR		0x18C
#define SIRCS_SOFTINT_SET		0x190
#define SIRCS_SOFTINT_CLEAR		0x194
# define  SIRCS_VALIDBITMASK		  0x00000007

#define JOG_RAW_STATUS			0x1c0
#define JOG_STATUS			0x1c4
#define JOG_ENABLE			0x1c8
#define JOG_ENABLE_CLEAR		0x1cC
#define JOG_SOFTINT_SET			0x1d0
#define JOG_SOFTINT_CLEAR		0x1d4
# define  JOG_VALIDBITMASK		  0x00000003

#define SIO_RAW_STATUS			0x1e0
#define SIO_STATUS			0x1e4
#define SIO_ENABLE			0x1e8
#define SIO_ENABLE_CLEAR		0x1eC
#define SIO_SOFTINT_SET			0x1f0
#define SIO_SOFTINT_CLEAR		0x1f4
# define  SIO_VALIDBITMASK		  0x0000000f

#define I2S_RAW_STATUS			0x200
#define I2S_STATUS			0x204
#define I2S_ENABLE			0x208
#define I2S_ENABLE_CLEAR		0x20C
#define I2S_SOFTINT_SET			0x210
#define I2S_SOFTINT_CLEAR		0x214
# define  I2S_VALIDBITMASK		  0x00000007

#define PCIBRIDGE_RAW_STATUS		0x280
#define PCIBRIDGE_STATUS		0x284
#define PCIBRIDGE_ENABLE		0x288
#define PCIBRIDGE_ENABLE_CLEAR		0x28C
#define PCIBRIDGE_SOFTINT_SET		0x290
#define PCIBRIDGE_SOFTINT_CLEAR		0x294
# define  PCIBRIDGE_VALIDBITMASK	  0x0000001f

#define USB_RAW_STATUS			0x2a0
#define USB_STATUS			0x2a4
#define USB_ENABLE			0x2a8
#define USB_ENABLE_CLEAR		0x2aC
#define USB_SOFTINT_SET			0x2b0
#define USB_SOFTINT_CLEAR		0x2b4
# define  USB_VALIDBITMASK		  0x00000003

#define TPU_RAW_STATUS			0x300
#define TPU_STATUS			0x304
#define TPU_ENABLE			0x308
#define TPU_ENABLE_CLEAR		0x30C
#define TPU_SOFTINT_SET			0x310
#define TPU_SOFTINT_CLEAR		0x314
# define  TPU_VALIDBITMASK		  0x0000001f

#define ADC_RAW_STATUS			0x320
#define ADC_STATUS			0x324
#define ADC_ENABLE			0x328
#define ADC_ENABLE_CLEAR		0x32C
#define ADC_SOFTINT_SET			0x330
#define ADC_SOFTINT_CLEAR		0x334
# define  ADC_VALIDBITMASK		  0x00000003

#define GPIO_RAW_STATUS			0x360
#define GPIO_STATUS			0x364
#define GPIO_ENABLE			0x368
#define GPIO_ENABLE_CLEAR		0x36C
#define GPIO_SOFTINT_SET		0x370
#define GPIO_SOFTINT_CLEAR		0x374
# define  GPIO_VALIDBITMASK		  0x0000ffff

#define SYSV_RAW_STATUS			0x4C0
#define SYSV_STATUS			0x4C4
#define SYSV_ENABLE			0x4C8
#define SYSV_ENABLE_CLEAR		0x4CC
#define SYSV_SOFTINT_SET		0x4D0
#define SYSV_SOFTINT_CLEAR		0x4D4
# define  SYSV_VALIDBITMASK		  0x000001ff


/* 
 *  Interrupt numbers
 * 
 */
#define INT_UART                        0
#define INT_SSP                         1
#define INT_TIMER                       2
#define INT_DMAC                        3
#define INT_SIRCS                       4
#define INT_I2C                         5
#define INT_JOG                         6
#define INT_SIO                         7
#define INT_I2S                         8
#define INT_ATA                         9
#define INT_CF                          10
#define INT_CML                         11
#define INT_PCI                         12
#define INT_USB                         13
#define INT_MS                          14
#define INT_MSIO                        15
#define INT_TPU                         16
#define INT_ADC                         17
#define INT_TP                          18
#define INT_GPIO                        19
#define INT_MXX                         20
#define INT_MBOX                        21
#define INT_VIDEO                       23
#define INT_CODEC                       24
#define INT_WSX                         25
#define INT_IMG                         26
#define INT_IMGMC                       27
#define INT_BUS                         28
#define INT_IMGV                        29
#define INT_SYSV                        30
#define INT_AUDIO                       31

#define CXD4105_SC_VALID_INT            0xFFFFFFFF  /* all bits */
#define MAXIRQNUM                       32
#define MAXFIQNUM                       32
#define MAXSWINUM                       32

#endif /* __REGS_INTCTRL_H__ */
