/*
 * include/asm-arm/arch-cxd4105/time.h
 *
 * OS timer definitions
 *
 * Copyright 2005,2006 Sony Corporation
 *
 * This code is based on include/asm-arm/arch-integrator/time.h.
 */
/*
 *  linux/include/asm-arm/arch-integrator/time.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <asm/system.h>
#include <asm/leds.h>

/*
 * How long is the timer interval?
 */
#define TM1ST	0x1000
#define TM1INT  0x0100
#define TM1CSPERIODIC   0x0000
#define TM1CSFREERUN    0x0030
#define TM1CKDIV128 0x0007
#define TM1CKDIV1 0x0000

//#define TIMER_INTERVAL	12800	/* 1.28MHz timer */
#if defined(CONFIG_ARCH_CXD4108)
#define TIMER_RELOAD	(2000000/HZ)	/* Is it OK? */
#define TICKS2USECS(x)	(((x) * 100)/200)	/* x / 1.28 */
#else /* (CXD4105) */
#define TIMER_RELOAD	(1280000/HZ)	/* Is it OK? */
#define TICKS2USECS(x)	(((x) * 100)/128)	/* x / 1.28 */
#endif

#ifdef CONFIG_CXD4105_UART3
# define TM_OFF 4
#else
# define TM_OFF 0
#endif
#define TIMER_FOR_TICK  (TM_OFF+0)
#define TIMER_FOR_SCHED (TM_OFF+1)
#define TIMER_FOR_APP   (TM_OFF+2)
#define TIMER_FOR_ETC   (TM_OFF+3)

/*
 * What does it look like?
 */
typedef struct TimerStruct {
	unsigned long TimerControl;		/* 0x00 */
	unsigned long TimerClear;		/* 0x04 */
	unsigned long TimerCompare;		/* 0x08 */
	unsigned long TimerRead;		/* 0x0c */
	unsigned long TimerLoad;		/* 0x10 */
} TimerStruct_t;

extern unsigned long (*gettimeoffset)(void);
