/*
 * include/asm-arm/arch-cxd4105/uncompress.h
 *
 * uncompress utility functions
 *
 * Copyright 2005,2006 Sony Corporation
 *
 * This code is based on include/asm-arm/arch-integrator/uncompress.h.
 */
/*
 *  linux/include/asm-arm/arch-integrator/uncompress.h
 *
 *  Copyright (C) 1999 ARM Limited
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* for CXD4105 UART2 */
#include <asm/sizes.h>
#include <asm/arch/platform.h>
#include <asm/arch/regs-uart.h>
#define AMBA_UART_DR	(*(volatile unsigned long *)(CXD4105_UART2_BASE+0))
#define AMBA_UART_FR	(*(volatile unsigned long *)(CXD4105_UART2_BASE+0x18))
#define AMBA_UART_IBRD	(*(volatile unsigned long *)(CXD4105_UART2_BASE+0x24))
#define AMBA_UART_FBRD	(*(volatile unsigned long *)(CXD4105_UART2_BASE+0x28))
#define AMBA_UART_LCRH	(*(volatile unsigned long *)(CXD4105_UART2_BASE+0x2c))
#define AMBA_UART_CR	(*(volatile unsigned long *)(CXD4105_UART2_BASE+0x30))

/*
 * This does not append a newline
 */
static void putstr(const char *s)
{
	while (*s) {
		while (AMBA_UART_FR & (1 << 5));

		AMBA_UART_DR = *s;

		if (*s == '\n') {
			while (AMBA_UART_FR & (1 << 5));

			AMBA_UART_DR = '\r';
		}
		s++;
	}
	while (AMBA_UART_FR & (1 << 3));
}

/*
 * nothing to do
 */
#define arch_decomp_setup()

#define arch_decomp_wdog()
