/*
 * Copied from linux/include/asm-arm/arch-sa1100/system.h
 * Copyright (c) 1999 Nicolas Pitre <nico@cam.org>
 */
#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H
#include <linux/config.h>
#include <asm/arch/hardware.h>
#include <asm/mach-types.h>

static inline void arch_idle(void)
{
	cpu_do_idle();
}

static inline void arch_reset(char mode)
{
#ifdef CONFIG_MACH_OMAP_OSK
	if (machine_is_omap_osk()) {
		omap_writel(WSPR_DISABLE_0, OMAP_16XX_WSPR);
		while (omap_readl(OMAP_16XX_WWPS) & WWPS_W_PEND_WSPR)
			continue;

		omap_writel(WSPR_DISABLE_1, OMAP_16XX_WSPR);
		while (omap_readl(OMAP_16XX_WWPS) & WWPS_W_PEND_WSPR)
			continue;

		omap_writel((1 << WCLR_PRE_SHIFT) | (0 << WCLR_PTV_SHIFT),
					OMAP_16XX_WCLR);
		while (omap_readl(OMAP_16XX_WWPS) & WWPS_W_PEND_WCLR)
			continue;

		omap_writel(0xffffffff, OMAP_16XX_WCRR);
		while (omap_readl(OMAP_16XX_WWPS) & WWPS_W_PEND_WCRR)
			continue;

		omap_writel(WSPR_ENABLE_0, OMAP_16XX_WSPR);
		while (omap_readl(OMAP_16XX_WWPS) & WWPS_W_PEND_WSPR)
			continue;

		omap_writel(WSPR_ENABLE_1, OMAP_16XX_WSPR);
		while (omap_readl(OMAP_16XX_WWPS) & WWPS_W_PEND_WSPR)
			continue;
	}
#endif
	omap_writew(1, ARM_RSTCT1);
}

#endif
