/*
 * include/asm-arm/hardware/serial_amba2.h
 *
 * UART definitions
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __SERIAL_AMBA2_H__
#define __SERIAL_AMBA2_H__

/* register definitions */
#define AMBAUART_RTO		0x1c	 /*  Receive timeout register */
#define UART_RTO_CHAR(x)	((x) * 8 * 16 - 1) /* RTO is (x)*8 bits-time */
#define UART_RTO_DEFAULT	32

/* bit definitions */
#define AMBAUART_CR_SIRINV	0x08

struct uart_platform_data {
	int chan;
	int uartclk;
	int fifosize;

	int tx_use_dma;
	int tx_dma_ch;
	int tx_dma_dev;

	int rx_use_dma;
	int rx_dma_ch;
	int rx_dma_dev;
	int rx_timeout;
};

#endif /* __SERIAL_AMBA2_H__ */
