/*
 * Copyright 2005  Sony Corporation
 */
#ifndef EXCEPTION_MONITOR_H
#define EXCEPTION_MONITOR_H
#ifdef CONFIG_EXCEPTION_MONITOR
extern int exception_check_mode;
extern void (*exception_check)(int mode, struct pt_regs *regs);
extern int stop_all_threads(struct mm_struct *mm);
extern void start_all_threads(struct mm_struct *mm);

static inline int  em_show_coredump(struct pt_regs *regs)
{
	if (exception_check_mode && exception_check) {
	/* Stop our siblings. We have the kernel lock, but schedule()
	   will nicely release it for us.  */
		if (stop_all_threads (current->mm) != 0)
			return -1;
		exception_check(exception_check_mode, regs);
	/* Restart our siblings (so they can die, or whatever). */
		start_all_threads(current->mm);
	}
	return 0;
}

static inline int  em_show(struct pt_regs *regs)
{
	if (exception_check_mode && exception_check) {
		exception_check(exception_check_mode, regs);
		return 1;
	}
	return 0;
}

static inline void em_show_stack_overflow(struct pt_regs *regs)
{
	if (exception_check_mode && exception_check) {
		die("stack overflow", regs, SIGSTKFLT);
	}
}
#else
static inline int  em_show_coredump(struct pt_regs *regs) { return 0; }
static inline int  em_show(struct pt_regs *regs) { return 0; }
static inline void em_show_stack_overflow(struct pt_regs *regs) {}
#endif /* CONFIG_EXCEPTION_MONITOR */
#endif /* EXCEPTION_MONITOR_H */
