/*
 * include/linux/rle.h
 * 
 * header file for RLE inflate/deflate
 * 
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __RLE_H__
#define __RLE_H__

#define RLE_COMPRESSED (0xF0)
#define RLE_RAW (0x0F)

#ifdef DEBUG
#ifdef __KERNEL__
#define rle_printf printk
#else
#define rle_printf printf
#endif
#else
#define rle_printf(fmt,arg...) 
#endif

int rle_deflate(void *src, int sl, void *dst, int dl);
int rle_inflate(void *src, int sl, void *dst, int dl, unsigned char **sd);
#endif
